package com.ruoyi.abuwx.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.abuwx.domain.WbMaintenanceInformation;

import java.util.List;

/**
 * 维保记录Mapper接口
 *
 * @author ruoyi
 * @date 2024-04-09
 */
public interface WbMaintenanceInformationMapper extends BaseMapper<WbMaintenanceInformation>
{
    /**
     * 查询维保记录
     *
     * @param id 维保记录主键
     * @return 维保记录
     */
    public WbMaintenanceInformation selectWbMaintenanceInformationById(Long id);

    /**
     * 查询维保记录列表
     *
     * @param wbMaintenanceInformation 维保记录
     * @return 维保记录集合
     */
    public List<WbMaintenanceInformation> selectWbMaintenanceInformationList(WbMaintenanceInformation wbMaintenanceInformation);

    /**
     * 新增维保记录
     *
     * @param wbMaintenanceInformation 维保记录
     * @return 结果
     */
    public int insertWbMaintenanceInformation(WbMaintenanceInformation wbMaintenanceInformation);

    /**
     * 修改维保记录
     *
     * @param wbMaintenanceInformation 维保记录
     * @return 结果
     */
    public int updateWbMaintenanceInformation(WbMaintenanceInformation wbMaintenanceInformation);

    /**
     * 删除维保记录
     *
     * @param id 维保记录主键
     * @return 结果
     */
    public int deleteWbMaintenanceInformationById(Long id);

    /**
     * 批量删除维保记录
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteWbMaintenanceInformationByIds(Long[] ids);
}
