package com.ruoyi.abuwx.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.abuwx.domain.WbMaintenanceInformation;

import java.util.List;

/**
 * 维保记录Service接口
 *
 * @author ruoyi
 * @date 2024-04-09
 */
public interface IWbMaintenanceInformationService extends IService<WbMaintenanceInformation>
{
    /**
     * 查询维保记录
     *
     * @param id 维保记录主键
     * @return 维保记录
     */
    public WbMaintenanceInformation selectWbMaintenanceInformationById(Long id);

    /**
     * 查询维保记录列表
     *
     * @param wbMaintenanceInformation 维保记录
     * @return 维保记录集合
     */
    public List<WbMaintenanceInformation> selectWbMaintenanceInformationList(WbMaintenanceInformation wbMaintenanceInformation);

    /**
     * 新增维保记录
     *
     * @param wbMaintenanceInformation 维保记录
     * @return 结果
     */
    public int insertWbMaintenanceInformation(WbMaintenanceInformation wbMaintenanceInformation);

    /**
     * 修改维保记录
     *
     * @param wbMaintenanceInformation 维保记录
     * @return 结果
     */
    public int updateWbMaintenanceInformation(WbMaintenanceInformation wbMaintenanceInformation);

    /**
     * 批量删除维保记录
     *
     * @param ids 需要删除的维保记录主键集合
     * @return 结果
     */
    public int deleteWbMaintenanceInformationByIds(Long[] ids);

    /**
     * 删除维保记录信息
     *
     * @param id 维保记录主键
     * @return 结果
     */
    public int deleteWbMaintenanceInformationById(Long id);

    /**
     * 根据项目id查询维保记录列表
     *
     * @param projectId 项目id
     * @return 维保记录集合
     */
    public List<WbMaintenanceInformation> selectWbMaintenanceInformationListByProjectId(Long projectId);
}
