package com.ruoyi.abuwx.service;

import com.ruoyi.abuwx.domain.WbProject;

import java.util.List;

/**
 * 项目管理Service接口
 *
 * @author ruoyi
 * @date 2024-04-08
 */
public interface IWbProjectService
{
    /**
     * 查询项目管理
     *
     * @param id 项目管理主键
     * @return 项目管理
     */
    public WbProject selectWbProjectById(Long id);

    /**
     * 查询项目管理列表
     *
     * @param wbProject 项目管理
     * @return 项目管理集合
     */
    public List<WbProject> selectWbProjectList(WbProject wbProject);

    /**
     * 新增项目管理
     *
     * @param wbProject 项目管理
     * @return 结果
     */
    public int insertWbProject(WbProject wbProject);

    /**
     * 修改项目管理
     *
     * @param wbProject 项目管理
     * @return 结果
     */
    public int updateWbProject(WbProject wbProject);

    /**
     * 批量删除项目管理
     *
     * @param ids 需要删除的项目管理主键集合
     * @return 结果
     */
    public int deleteWbProjectByIds(Long[] ids);

    /**
     * 删除项目管理信息
     *
     * @param id 项目管理主键
     * @return 结果
     */
    public int deleteWbProjectById(Long id);
}
