package com.ruoyi.abuwx.service.impl;

import com.ruoyi.abuwx.domain.WbProject;
import com.ruoyi.abuwx.mapper.WbProjectMapper;
import com.ruoyi.abuwx.service.IWbProjectService;
import com.ruoyi.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 项目管理Service业务层处理
 *
 * @author ruoyi
 * @date 2024-04-08
 */
@Service
public class WbProjectServiceImpl implements IWbProjectService
{
    @Autowired
    private WbProjectMapper wbProjectMapper;

    /**
     * 查询项目管理
     *
     * @param id 项目管理主键
     * @return 项目管理
     */
    @Override
    public WbProject selectWbProjectById(Long id)
    {
        return wbProjectMapper.selectWbProjectById(id);
    }

    /**
     * 查询项目管理列表
     *
     * @param wbProject 项目管理
     * @return 项目管理
     */
    @Override
    public List<WbProject> selectWbProjectList(WbProject wbProject)
    {
        return wbProjectMapper.selectWbProjectList(wbProject);
    }

    /**
     * 新增项目管理
     *
     * @param wbProject 项目管理
     * @return 结果
     */
    @Override
    public int insertWbProject(WbProject wbProject)
    {
        wbProject.setCreateTime(DateUtils.getNowDate());
        return wbProjectMapper.insertWbProject(wbProject);
    }

    /**
     * 修改项目管理
     *
     * @param wbProject 项目管理
     * @return 结果
     */
    @Override
    public int updateWbProject(WbProject wbProject)
    {
        wbProject.setUpdateTime(DateUtils.getNowDate());
        return wbProjectMapper.updateWbProject(wbProject);
    }

    /**
     * 批量删除项目管理
     *
     * @param ids 需要删除的项目管理主键
     * @return 结果
     */
    @Override
    public int deleteWbProjectByIds(Long[] ids)
    {
        return wbProjectMapper.deleteWbProjectByIds(ids);
    }

    /**
     * 删除项目管理信息
     *
     * @param id 项目管理主键
     * @return 结果
     */
    @Override
    public int deleteWbProjectById(Long id)
    {
        return wbProjectMapper.deleteWbProjectById(id);
    }
}
