package com.ruoyi.abuwxapi;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.abuwx.domain.WbMaintenanceInformation;
import com.ruoyi.abuwx.domain.WbProject;
import com.ruoyi.abuwx.service.IAbucoderWxappConfigService;
import com.ruoyi.abuwx.service.IAbucoderWxuserService;
import com.ruoyi.abuwx.service.IWbMaintenanceInformationService;
import com.ruoyi.abuwx.service.IWbProjectService;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.constant.HttpStatus;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.entity.AbucoderWxuser;
import com.ruoyi.common.core.domain.entity.SysRole;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.common.utils.file.FileUtils;
import com.ruoyi.common.utils.http.HttpUtils;
import com.ruoyi.framework.config.ServerConfig;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.system.mapper.SysUserMapper;
import com.ruoyi.system.service.ISysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/wxapi/")
public class WxLoginController extends BaseController {

    /**
     * 测试接口
     * @return
     */
    @GetMapping("test")
    public AjaxResult test(){
        return success("小程序api调试成功！~");
    }

    @Autowired
    private IAbucoderWxuserService iAbucoderWxuserService;

    @Autowired
    private IAbucoderWxappConfigService wxappConfigService;

    @Autowired
    private ServerConfig serverConfig;

    @Autowired
    private TokenService tokenService;

    @Autowired
    private IWbMaintenanceInformationService wbMaintenanceInformationService;

    @Autowired
    private ISysUserService iSysUserService;

    @Autowired
    private SysUserMapper userMapper;

    @Autowired
    private IWbProjectService iWbProjectService;
    /**
     * 你自己的微信小程序APPID
     */

    private final static String AppID = "wxd4b42fedb37bff38";
    /**
     * 你自己的微信APP密钥
     */
    private final static String AppSecret = "0e3fd6228e183ec3f6e35be89c7b6994";

    /**
     * 登录时获取的 code（微信官方提供的临时凭证）
     * @param object
     * @return
     */
    @PostMapping("/wxlogin")
    public AjaxResult wxLogin(@RequestBody JSONObject object){
        //微信官方提供的微信小程序登录授权时使用的URL地址
        String url  = "https://api.weixin.qq.com/sns/jscode2session";
        System.out.println(object);

        /**
         * 拼接需要的参数
         * appid = AppID 你自己的微信小程序APPID
         * js_code = AppSecret 你自己的微信APP密钥
         * grant_type=authorization_code = code 微信官方提供的临时凭证
         */
        String params = StrUtil.format("appid={}&secret={}&js_code={}&grant_type=authorization_code", AppID, AppSecret, object.get("code"));
        //开始发起网络请求,若依管理系统自带网络请求工具，直接使用即可
        String res = HttpUtils.sendGet(url,params);
        JSONObject jsonObject = JSON.parseObject(res);
        String openid = (String) jsonObject.get("openid");
        if (StrUtil.isEmpty(openid)) {
            return error("未获取到openid");
        }
        /**先通过openid来查询是否存在*/
        AbucoderWxuser abucoderWxuser = iAbucoderWxuserService.selectAbucoderWxuserOpenID(openid);
        if (abucoderWxuser == null){
            /**如果不存在就插入到我们的数据库里*/
            abucoderWxuser = new AbucoderWxuser();
            abucoderWxuser.setOpenid(openid);
            abucoderWxuser.setCreateTime(DateUtils.getNowDate());
            iAbucoderWxuserService.insertAbucoderWxuser(abucoderWxuser);
            /**返回结果集到前段*/

        }
        return success(abucoderWxuser).put("token", getToken(abucoderWxuser));

    }

    @PostMapping("/upload")
    @ResponseBody
    public AjaxResult uploadFile(MultipartFile file) throws Exception
    {
        System.out.println(file);
        try
        {
            // 上传文件路径
            String filePath = RuoYiConfig.getUploadPath();
            // 上传并返回新文件名称
            String fileName = FileUploadUtils.upload(filePath, file);
            String url = serverConfig.getUrl() + "/prod-api"+ fileName;
            AjaxResult ajax = success();
            ajax.put("url", url);
            ajax.put("fileName", fileName);
            ajax.put("newFileName", FileUtils.getName(fileName));
            ajax.put("originalFilename", file.getOriginalFilename());
            return ajax;
        }
        catch (Exception e)
        {
            return error(e.getMessage());
        }
    }

    /**
     * 保存昵称与头像信息到用户信息里
     * @param object
     * @return
     */
    @PostMapping("/saveUserInfo")
    @ResponseBody
    public AjaxResult saveUserInfo(@RequestBody JSONObject object){
        System.out.println(object);
        AbucoderWxuser abucoderWxuser = iAbucoderWxuserService.selectAbucoderWxuserOpenID(String.valueOf(object.get("openid")));
        if (StringUtils.hasLength(String.valueOf(object.get("nickName")))){
            abucoderWxuser.setNickname(String.valueOf(object.get("nickName")));
            abucoderWxuser.setCreateBy(String.valueOf(object.get("nickName")));
        }
        if (StringUtils.hasLength(String.valueOf(object.get("avatarUrl")))){
            abucoderWxuser.setAvatar(String.valueOf(object.get("avatarUrl")));
        }
        abucoderWxuser.setUpdateTime(DateUtils.getNowDate());
        iAbucoderWxuserService.updateAbucoderWxuser(abucoderWxuser);
        //返回前段需要的数据
        return success(abucoderWxuser);
    }

    private String getToken(AbucoderWxuser wxuser){
        LoginUser loginUser = new LoginUser();
        loginUser.setWxuser(wxuser);
        return tokenService.createToken(loginUser);
    }

/*    *//**
     *
     *
     * 根据项目id获取维保记录列表
     *//*
    @RequestMapping("/informationList")
    public AjaxResult getInformationList(@RequestParam Long projectId)
    {
        return success(wbMaintenanceInformationService.selectWbMaintenanceInformationListByProjectId(projectId))
                .put("total",wbMaintenanceInformationService.selectWbMaintenanceInformationListByProjectId(projectId).size());
    }*/

    /**
     * 小程序分页查询维保记录列表
     */
    @GetMapping("/informationList")
    public TableDataInfo list(WbMaintenanceInformation wbMaintenanceInformation)
    {
        startPage();
        List<WbMaintenanceInformation> list = wbMaintenanceInformationService.selectWbMaintenanceInformationList(wbMaintenanceInformation);
        return getDataTable(list);
    }

    /**
     * 获取维保记录详细信息
     */
    @RequestMapping(value = "/infoId")
    public AjaxResult getInformation(@RequestParam Long id)
    {
        return success(wbMaintenanceInformationService.selectWbMaintenanceInformationById(id));
    }

    /**
     * 绑定维保用户
     */
    @PostMapping("/bindWbuser")
    public AjaxResult bindWbuser(@RequestBody SysUser sysUser){
        String username = sysUser.getUserName();
        String password = sysUser.getPassword();
        String openid = sysUser.getOpenid();
        List<SysUser> userList = iSysUserService.selectList();
        List<SysUser> collect = userList.stream().filter(data -> data.getOpenid() != null
                && data.getOpenid().equals(openid)).collect(Collectors.toList());
        if(collect.size() != 0){
            //当前用户已绑定过角色
            return error("当前用户已绑定过角色!");
        }
        //校验传递的用户名、密码、openid都不为空
        if(StringUtils.isEmpty(username) || StringUtils.isEmpty(password) || StringUtils.isEmpty(openid)){
            return error();
        }
        //根据传递的用户名获取用户信息
        SysUser user = iSysUserService.selectUserByUserName(username);
        if(user == null){
            return error("账号或密码错误！");
        }
        if(!StringUtils.isEmpty(user.getOpenid())){
            return error("账号已绑定！");
        }
        //校验密码是否正确
        boolean b = SecurityUtils.matchesPassword(user.getPassword(), password);
        if (!SecurityUtils.matchesPassword(user.getPassword(), password)) {
            user.setOpenid(openid);
            userMapper.updateUser(user);
        }
        return success(user);
    }

    /**
     * 新增维保记录
     */
    @PostMapping("/addWbMaintenanceInformation")
    public AjaxResult addWbMaintenanceInformation(@RequestBody WbMaintenanceInformation wbMaintenanceInformation)
    {
        return success(wbMaintenanceInformationService.insertWbMaintenanceInformation(wbMaintenanceInformation));
    }

    /**
     * 根据openid查询当前微信用户角色
     */
    @RequestMapping("/selectWXuserRole")
    public AjaxResult selectWXuserRole(@RequestParam String openid){
        if (StringUtils.isEmpty(openid)){
            List<Object> data = new ArrayList<>();
            data.add(0);
            return new AjaxResult(HttpStatus.SUCCESS,"roleIds",data);
        }
        //获取当前用户信息
        SysUser user = iSysUserService.selectUserByopenid(openid);
        if(user == null){
            //return success("roleIds",0);
            List<Object> data = new ArrayList<>();
            data.add(0);
            return new AjaxResult(HttpStatus.SUCCESS,"roleIds",data);
        }
        SysUser newUser = iSysUserService.selectUserById(user.getUserId());
//        List<SysRole> roles = user.getRoles();
//        List<Long> collect = roles.stream().map(SysRole::getRoleId).collect(Collectors.toList());
//        return  success("roleIds",collect);
        //return success("roleIds", newUser.getRoles().stream().map(SysRole::getRoleId).collect(Collectors.toList()));
        return new AjaxResult(HttpStatus.SUCCESS,"roleIds", newUser.getRoles().stream().map(SysRole::getRoleId).collect(Collectors.toList()));
    }

    /**
     * 小程序分页查询查询项目管理列表
     */
    @GetMapping("/projectList")
    public TableDataInfo list(WbProject wbProject)
    {
        startPage();
        List<WbProject> list = iWbProjectService.selectWbProjectList(wbProject);
        return getDataTable(list);
    }

    /**
     * 小程序根据项目id获取项目管理详细信息
     */
    @RequestMapping(value = "/infoProjectId")
    public AjaxResult getInfo(@RequestParam Long projectId)
    {
        return success(iWbProjectService.selectWbProjectById(projectId));
    }
}
